import es

class Event(dict):
    def __init__(self, event_name):
        self._event_name = event_name
        self._attrs = {}
    def __setattr__(self, attr, value):
        if attr[0] == '_':
            return super(Event, self).__setattr__(attr,value)
        self[attr] = value
    def __getattr__(self, attr):
        if attr.startswith(('_', 'iter')):
            return super(Event, self).__getattr__(attr,value)
        return self[attr]
    def fire(self):
        event_name = self._event_name
        es.event('initialize', event_name)
        for name, value in self.iteritems():
            if isinstance(value, int):
                es.event('setint', event_name, name, value)
            elif isinstance(value, float):
                es.event('setfloat', event_name, name, value)
            else:
                es.event('setstring', event_name, name, value)
        es.event('fire', event_name)

class DebugEvent(Event):
    def fire(self):
        event_name = self._event_name
        es.dbgmsg(0, 'DebugEvent %s initialize'%(event_name,))
        for name, value in self.iteritems():
            if isinstance(value, int):
                es.dbgmsg(0, '%-9s %-15s = %d'%('(int)', name, value))
            elif isinstance(value, float):
                es.dbgmsg(0, '%-9s %-15s = %0.6f'%('(float)', name, value))
            else:
                es.dbgmsg(0, '%-9s %-15s = %s'%('(string)', name, repr(value)))
        es.dbgmsg(0, 'DebugEvent %s "fired".'%(event_name,))

